package xlogo.kernel;

import java.util.Stack;
import java.awt.Color;
import xlogo.gui.Editor;

/**
 * Title :        XLogo
 * Description :  XLogo is an interpreter for the Logo 
 * 						programming language
 * @author Loïc Le Coq
 */
import xlogo.Application;
public class Kernel {
	protected static long chrono = 0;
	protected static Stack flux=new Stack(); // Contient les flux de lecture ou d'écriture
	protected static Stack chemin_flux=new Stack(); // Contient le chemin absolu vers chacun des fichiers
	protected static Stack description_flux=new Stack(); // Contient les identifiants de chacun des fluxs
	protected static Stack fin_flux=new Stack(); // Contient 1 si la fin du flux est atteinte rien sinon
	protected static boolean mode_trace=false; // true si le mode trace est enclenchée (permet de suivre les procédures)
	
	// interprete the user command and launch primitive and procedure
	private Interprete interprete;
	// For all drawing operation
	protected DrawGraphics dg;
	// For primitive 
	protected Primitive primitive = null;
	private Workspace wp;
	private Application app;
	public Kernel(Application app){
		this.app=app;
		this.wp=new Workspace();
	}
	 public Workspace getWorkspace(){
	 	return wp;	
	 }
	 public void setWorkspace(Workspace workspace){
		 	wp=workspace;
		 	app.editeur=new Editor(app);
		 	interprete.setWorkspace(wp);
		 }
	 protected String listSearch() throws xlogo.utils.myException{
	 	return interprete.chercheListe();
	 }
	 public void fcfg(Color color){
	 	dg.fcfg(color);
	 }
	 public void fcc(Color color){
	 	dg.fcc(color);
	 }
	 public Color getScreenBackground(){
	 	return dg.getScreenBackground();
	 }
	 public void buildPrimitiveTreemap(int id){
	 	primitive.buildPrimitiveTreemap(id);
	 }
	 public void setDrawingQuality(int id){
	 	dg.setQuality(id);
	}
	public void change_image_tortue(String chemin){
		dg.change_image_tortue(app,chemin);
	}
	public void vide_ecran(){
		dg.videecran();
	}
	public Turtle getActiveTurtle(){
		return dg.tortue;
	}
	public void setNumberOfTurtles(int i){
		dg.setNumberOfTurtles(i);
	}
	 public String execute(StringBuffer st) throws xlogo.utils.myException{
	 	return interprete.execute(st);
	 }
	 public void rafraichis(){
	 	dg.rafraichis();
	 }
	 public void initDrawGraphics(){
	 	dg=new DrawGraphics(app);
	 }
	 public void initPrimitive(){
	 	primitive=new Primitive(app);	
	 }
	 public void initInterprete(){
		interprete=new Interprete(app);
	 }
	 public void updateGraphics(){
		 dg.updateGraphics();
	 }
}
